#ifdef _OLE
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <ole2.h>
#include "ExcelDef.h"
#include "MsgLocale.h"

//HRESULT AutoWrap(int autoType, VARIANT *pvResult, IDispatch *pDisp, LPOLESTR ptName, int cArgs, ...) {
int AutoWrap(HRESULT *hr, int autoType, VARIANT *pvResult, IDispatch *pDisp, LPOLESTR ptName, int cArgs, ...) {
	// Variables used...
	DISPPARAMS dp = { NULL, NULL, 0, 0 };
	DISPID dispidNamed = DISPID_PROPERTYPUT;
	DISPID dispID;
	VARIANT *pArgs;
//	HRESULT hr;
	char buf[200];
	char szName[200];
	int ir;

	// Allocate memory for arguments...
	int i;

	// Begin variable-argument list...
	va_list marker;
	va_start(marker, cArgs);
	if(!pDisp) {
		MessageBox(hWnd, "NULL IDispatch passed to AutoWrap()", "Error", 0x10010);
		va_end(marker);
		ir = ExcelEnd(0);
		FreeArea();
//		_exit(0);
		return OLE_ERROR;
	}

	// Convert down to ANSI
	WideCharToMultiByte(CP_ACP, 0, ptName, -1, szName, 256, NULL, NULL);

	// Get DISPID for name passed...
	*hr = pDisp->GetIDsOfNames(IID_NULL, &ptName, 1, LOCALE_USER_DEFAULT, &dispID);
//	hr = pDisp->lpVtbl->GetIDsOfNames(pDisp, &IID_NULL, &ptName, 1, LOCALE_USER_DEFAULT, &dispID);
	if(FAILED(*hr)) {
#if _MSC_VER > 1200
		sprintf_s(buf, sizeof(buf),
			  "IDispatch::GetIDsOfNames(\"%s\") failed w/err0x%08lx",
			  szName, *hr);
#else  //MSC
//VC6 ȉ
		sprintf(buf,
			  "IDispatch::GetIDsOfNames(\"%s\") failed w/err0x%08lx",
			  szName, *hr);
#endif  //MSC
		MessageBox(hWnd, buf, "AutoWrap()", 0x10010);
		va_end(marker);
		ir = ExcelEnd(0);
		FreeArea();
//		_exit(0);
		return OLE_ERROR;
	}

	try{
		// Allocate memory for arguments...
		pArgs = new VARIANT[cArgs+1];
	}
	catch (...) {
//		MessageDisp( MSG_ER_MEM3_CODE );
		va_end(marker);
		ir = ExcelEnd(0);
		FreeArea();
//		return MEMORY_ERROR;
		return OLE_ERROR;//{́u𑀍ł܂Bvuf[^ϊɎs܂Bv
	}
	// Extract arguments...
	for(i=0; i<cArgs; i++) {
		pArgs[i] = va_arg(marker, VARIANT);
	}

	// Build DISPPARAMS
	dp.cArgs = cArgs;
	dp.rgvarg = pArgs;

	// Handle special-case for property-puts!
	if(autoType & DISPATCH_PROPERTYPUT) {
		dp.cNamedArgs = 1;
		dp.rgdispidNamedArgs = &dispidNamed;
	}

	// Make the call!
	*hr = pDisp->Invoke(dispID, IID_NULL, LOCALE_SYSTEM_DEFAULT, autoType, &dp, pvResult, NULL, NULL);
//	hr = pDisp->lpVtbl->Invoke(pDisp, dispID, &IID_NULL, LOCALE_SYSTEM_DEFAULT, (WORD)autoType, &dp, pvResult, NULL, NULL);
	if(FAILED(*hr)) {
#if _MSC_VER > 1200
		sprintf_s(buf, sizeof(buf),
			  "IDispatch::Invoke(\"%s\"=%08lx) failed w/err 0x%08lx", 
			  szName, dispID, *hr);
#else  //MSC
//VC6 ȉ
		sprintf(buf,
			  "IDispatch::Invoke(\"%s\"=%08lx) failed w/err 0x%08lx", 
			  szName, dispID, *hr);
#endif  //MSC
		MessageBox(hWnd, buf, "AutoWrap()", 0x10010);
		va_end(marker);
		delete [] pArgs;
		ir = ExcelEnd(0);
		FreeArea();
//		_exit(0);
		return OLE_ERROR;
	}
	// End variable-argument section...
	va_end(marker);

	delete [] pArgs;

	return NOMAL_RETURN;
}
#endif  //_OLE
