//*****************************************************************************
//* Copyright (c) 2001-2012 Miday Workshop All rights reserved.
//*
//* File: ClipWrite.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#include <new>
#include <wchar.h>
#include "ExcelDef.h"
#include "MsgLocale.h"

//==============================================================================
//Nbv{[hɃf[^o͂
//==============================================================================
int ClipWrite(UNICHAR *wkdata) {
	int irc, ia;
	BOOL irt;
	HANDLE hClip;
	HGLOBAL  hGlobal, hGlobal_p;

	for(ia=0; ia<ClipWaitCount; ia++) {
		irt = OpenClipboard(hWnd);
		if ( irt == TRUE ) break;
		Sleep(ClipWaitTime);
	}
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP1_CODE );
		return FINISHING_MESSAGE;
	}
	irt = EmptyClipboard();
	if ( irt == FALSE ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_CLP2_CODE );
		return FINISHING_MESSAGE;
	}
#ifdef _UNICODE_TABLE
	int sizew = (wcstombs( NULL, (wchar_t*)wkdata, 0)+1) * sizeof(UNICHAR);
	if ( sizew == 0 ) {
		sizew = MTRLEN(wkdata) * 16;//傫߂Ɋm
	}
	hGlobal = GlobalAlloc (GMEM_DDESHARE | GMEM_MOVEABLE, sizew);
#else  //_UNICODE_TABLE
	hGlobal = GlobalAlloc (GMEM_DDESHARE | GMEM_MOVEABLE, MTRLEN(wkdata)+1);
#endif  //_UNICODE_TABLE

	if ( hGlobal == NULL ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
	hGlobal_p = (LPTSTR) GlobalLock(hGlobal);
	if ( hGlobal_p == NULL ) {
		irt = CloseClipboard();
		hGlobal_p = GlobalFree(hGlobal);
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
	MTRCPY ( (UNICHAR *)hGlobal_p, MTRLEN(wkdata)+1, wkdata);
	SetLastError(NO_ERROR);
	irt = GlobalUnlock(hGlobal);
	if ( irt == FALSE ) {
		if ( GetLastError() != NO_ERROR ) {
			irt = CloseClipboard();
			hGlobal_p = GlobalFree(hGlobal);
			irc = MessageDisp( MSG_ER_MEM3_CODE );
			return MEMORY_ERROR;
		}
	}
#ifdef _UNICODE_TABLE
	hClip = SetClipboardData(CF_UNICODETEXT, (wchar_t*)hGlobal);
#else  //_UNICODE_TABLE
	hClip = SetClipboardData(CF_TEXT, hGlobal);
#endif  //_UNICODE_TABLE
	if ( hClip == NULL ) {
		irt = CloseClipboard();
		hGlobal_p = GlobalFree(hGlobal);
		irc = MessageDisp( MSG_ER_CLP3_CODE );
		return FINISHING_MESSAGE;
	}
	irt = CloseClipboard();
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP4_CODE );
		return FINISHING_MESSAGE;
	}
//	hGlobal_p = GlobalFree(hGlobal);

	return NOMAL_RETURN;
}

//==============================================================================
//Nbv{[hf[^͂
//==============================================================================
int ClipRead(UNICHAR **wkdata) {
	int irc, ia;
	BOOL irt;
	HGLOBAL  hGlobal, hGlobal_p;

	for(ia=0; ia<ClipWaitCount; ia++) {
		irt = OpenClipboard(hWnd);
		if ( irt == TRUE ) break;
		Sleep(ClipWaitTime);
	}
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP5_CODE );
		return FINISHING_MESSAGE;
	}

#ifdef _UNICODE_TABLE
	hGlobal = GetClipboardData(CF_UNICODETEXT);
#else  //_UNICODE_TABLE
	hGlobal = GetClipboardData(CF_TEXT);
#endif  //_UNICODE_TABLE
	if ( hGlobal == NULL ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_CLP6_CODE );
		return FINISHING_MESSAGE;
	}

	hGlobal_p = (LPTSTR) GlobalLock(hGlobal);
	if ( hGlobal_p == NULL ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}

	try{
		*wkdata = new UNICHAR[MTRLEN((UNICHAR *)hGlobal_p)+1];
	}
#if _MSC_VER > 1200
	catch (std::bad_alloc) {
#else  //MSC
//VC6 ȉ
	catch (...) {
#endif  //MSC
		irt = GlobalUnlock(hGlobal);
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
#if _MSC_VER > 1200
	catch (...) {
		irt = GlobalUnlock(hGlobal);
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
#endif  //MSC
	MTRCPY ( *wkdata, MTRLEN((UNICHAR *)hGlobal_p)+1, (UNICHAR *)hGlobal_p );
	SetLastError(NO_ERROR);
	irt = GlobalUnlock(hGlobal);
	if ( irt == FALSE ) {
		if ( GetLastError() != NO_ERROR ) {
			FreeArea();
			irt = CloseClipboard();
			irc = MessageDisp( MSG_ER_MEM3_CODE );
			return MEMORY_ERROR;
		}
	}
	irt = CloseClipboard();
	if ( irt == FALSE ) {
		FreeArea();
		irc = MessageDisp( MSG_ER_CLP7_CODE );
		return FINISHING_MESSAGE;
	}

	return NOMAL_RETURN;
}

//==============================================================================
//Nbv{[hɃf[^邩`FbN
//==============================================================================
int ClipCheck() {
	unsigned int uFormat;
	int  data_type, ia, irc;
	BOOL irt;
	data_type = 0;
	uFormat = 0;

	for(ia=0; ia<ClipWaitCount; ia++) {
		irt = OpenClipboard(hWnd);
		if ( irt == TRUE ) break;
		Sleep(ClipWaitTime);
	}
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP5_CODE );
		return FINISHING_MESSAGE;
	}

	while((uFormat = EnumClipboardFormats(uFormat)) != 0) {
		if(uFormat == CF_TEXT ) {
			data_type = 1;
			break;
		}
	}
	CloseClipboard();
	if ( data_type == 0 ) {
		irc = MessageDisp( MSG_ER_CLP8_CODE );
	}
	return data_type;
}
#endif  //_WINDOWS_PLAT
