//*****************************************************************************
//* Copyright (c) 2012-2013 Miday Workshop All rights reserved.
//*
//* File: ExcelCom.cpp
//*****************************************************************************

#include <windows.h>
#include <new>
#include <string.h>
#include <wchar.h>
#include "ExcelDef.h"
#include "MsgLocale.h"

//p[^͂̕ϐ
UNICHAR AppPath[FILENAME_SIZE];    //AvP[VpX
UNICHAR Inifile[FILENAME_SIZE];    //InitFile
int ClipWaitCount, ClipWaitTime, TimeLog, AsciiWide, HoriWide;
#ifdef _UNICODE_TABLE
wchar_t Locale[500];
#endif  //_UNICODE_TABLE
int VerChk;

#ifdef _WINDOWS_PLAT
SYSTEMTIME Just1, Just2;
#else  //_WINDOWS_PLAT
#include <time.h>
struct tm *Just1, *Just2;
#endif  //_WINDOWS_PLAT

CELL *hyo;
#if defined(_JPN) || defined(_ENG)
POS *yoko_p;
POS *tate_p;
#endif
CHAR_LEN out_data;
CHAR_LEN out_wk_data;
UNICHAR *clip_data;
int *font_attr;
int *cell_attr;

int Col_no, Row_no;

int Break_flag;//=0 LZ@=1 LZ@=2 LZI
int Allline_flag;//=0 mF@=1 SĂ̘gt邱ƂmF
int Test_flag;//=NOTEST {ԁ@=TEST eXg
int Area_pos;//̈mۏ͂ǂ܂Ői񂾂
int Out_alloc;//o͗p̗̈mۂ
int Out_wk_alloc;//Ɨp̗̈mۂ
int Clip_alloc;//Nbv{[gf[^荞񂾂
int Proc_pos;//s͂ǂ܂Ői񂾂
int Use_pos;//ϐgp͂ǂ܂Ői񂾂
int Use_flag[10];//ϐ͎gpĂ邩

int font_attr_maxno;//f[^̐
int font_attr_no;//ݎgp̕f[^̔ԍ
int font_attr_alloc;//f[^̗̈mۂ
int cell_attr_maxno;//Zf[^̐
int cell_attr_no;//ݎgp̃Zf[^̔ԍ
int cell_attr_alloc;//Zf[^̗̈mۂ

int text_flag;//Nbv{[h̃f[^̗L

//==============================================================================
//̎w͈͂1oCg邩`FbN
//==============================================================================
int HalfCheck(UNICHAR *indata, int sa, int ea) {
	int ja, ma;
	ja = 0;
	for(ma=sa; ma<=ea; ma++) {
#ifdef _UNICODE_TABLE
		if ( indata[ma] >= LIT_K61 && indata[ma] <= LIT_K9F ) {
			ja++;
		} else {
#endif  //_UNICODE_TABLE
			if ( indata[ma] < LIT_KFF ) {
				ja++;
			}
#ifdef _UNICODE_TABLE
		}
#endif  //_UNICODE_TABLE
	}
	return ja;
}

//==============================================================================
//̈mۂ
//==============================================================================
int AllocArea() {
	int ia, irc;

	try{
		hyo = new CELL[(Row_no)*(Col_no)];
		for (ia=0; ia<Col_no*Row_no; ia++ ) {
			hyo[ia].text.size = -1;
			hyo[ia].merge[AR_FLAG] = 0;
		}
		Area_pos = 1;
#if defined(_JPN) || defined(_ENG)
		yoko_p = new POS[Col_no];
#endif
		Area_pos = 2;
#if defined(_JPN) || defined(_ENG)
		tate_p = new POS[Row_no];
#endif
		Area_pos = 3;
#if defined(_JPN) || defined(_ENG)
		for ( ia=0; ia<Col_no; ia++ ) {
			yoko_p[ia].posp = 0;
			yoko_p[ia].posw = 0;
		}
		for ( ia=0; ia<Row_no; ia++ ) {
			tate_p[ia].posp = 0;
			tate_p[ia].posw = 0;
		}
#endif
	}
#if _MSC_VER > 1200
	catch (std::bad_alloc) {
#else
//VC6 ȉ
	catch (...) {
#endif
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
#if _MSC_VER > 1200
	catch (...) {
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
#endif
	return NOMAL_RETURN;
}

//==============================================================================
//̈J out_dataclip_dataJ
//==============================================================================
void FreeArea() {
//ȉ͌
//LZG[@̃t@CĂ
//OLE G[@@@@@@@@AutoWrapĂ
//̑̃G[@@@@@@ExcelGetĂ
	int ia;

	if ( Area_pos >= 1 ) {
		for (ia=0; ia<Col_no*Row_no; ia++ ) {
			if ( hyo[ia].text.size != -1 ) {
				CharLenFree(&hyo[ia].text);
			}
		}
		delete[] hyo;
	}
#if defined(_JPN) || defined(_ENG)
	if ( Area_pos >= 2 ) delete[] yoko_p;
	if ( Area_pos >= 3 ) delete[] tate_p;
#endif

	if ( Out_alloc == 1 ) CharLenFree(&out_data);

	if ( Out_wk_alloc == 1 ) CharLenFree(&out_wk_data);

	if ( Clip_alloc == 1 ) delete[] clip_data;

	if ( font_attr_alloc == 1 ) delete[] font_attr;

	if ( cell_attr_alloc == 1 ) delete[] cell_attr;

	Area_pos         = 0;
	Out_alloc        = 0;
	Out_wk_alloc     = 0;
	Clip_alloc       = 0;
	font_attr_alloc  = 0;
	cell_attr_alloc  = 0;
}

//==============================================================================
//w肳ꂽ̐擪oCg`FbNAɉoCg邩Ԃ
//VtgJIS EUC-JP ̏
//==============================================================================
int ByteChk(UNICHAR ch) {
#ifdef _WINDOWS_PLAT
	return 0;
#ifdef _UNICODE_TABLE
#else  //_UNICODE_TABLE
	//VtgJIS
	if ((ch >= LIT_H81 && ch <= LIT_H9F) || (ch >= LIT_HE0 && ch <= LIT_HFC)) {
		return 1;
	}
#endif  //_UNICODE_TABLE
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
	return 0;
#else  //_UNICODE_TABLE
	//EUC-JP   eXgĂȂ
	if ((ch == LIT_H8E) || (ch >= LIT_HA1 && ch <= LIT_HFE)) {
		return 1;
	} else if (ch == LIT_H8F) {
		return 2;
	}
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT
	return 0;
}
