//*****************************************************************************
//* Copyright (c) 2009-2013 Miday Workshop All rights reserved.
//*
//* File: FileIo.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#else  //_WINDOWS_PLAT
#include <dirent.h>
#include <stdint.h>
#endif  //_WINDOWS_PLAT
#include <string.h>
#include <stdlib.h>
#include <wchar.h>
#include <stdio.h>
#include "ExcelDef.h"
#include "FileIo.h"
#include "MsgLocale.h"

#ifdef _LINUX_PLAT
//==============================================================================
//fopen̈ wchar_t* ɂbp[
//==============================================================================
FILE* wfopen(wchar_t* a, wchar_t* b) {
	FILE *fp;
	char *c, *d;
	int sizew, sizew2;
	sizew = wcstombs( NULL, a, 0);
	if ( sizew == -1 ) return NULL;
	try{
		c = new char[sizew+1];
	}
	catch (...) {
		return NULL;
	}
	sizew2 = wcstombs( c, a, sizew);
	c[sizew] = '\0';

	sizew = wcstombs( NULL, b, 0);
	if ( sizew == -1 ) {
		delete[] c;
		return NULL;
	}
	try{
		d = new char[sizew+1];
	}
	catch (...) {
		delete[] c;
		return NULL;
	}
	sizew2 = wcstombs( d, b, sizew);
	d[sizew] = '\0';

	fp = fopen(c, d);

	delete[] c;
	delete[] d;

	return fp;
}

//==============================================================================
//opendir̈ wchar_t* ɂbp[
//==============================================================================
DIR* wopendir(wchar_t* a) {
	DIR *dr;
	char *b;
	int sizew, sizew2;
	sizew = wcstombs( NULL, a, 0);
	if ( sizew == -1 ) return NULL;
	try{
		b = new char[sizew+1];
	}
	catch (...) {
		return NULL;
	}
	sizew2 = wcstombs( b, a, sizew);
	b[sizew] = '\0';

	dr = opendir(b);

	delete[] b;

	return dr;
}

//==============================================================================
//setenv̈ wchar_t* ɂbp[
//==============================================================================
int wsetenv(wchar_t* a, wchar_t* b, int c) {
	int ir;
	char *d, *e;
	int sizew, sizew2;
	sizew = wcstombs( NULL, a, 0);
	if ( sizew == -1 ) return -1;
	try{
		d = new char[sizew+1];
	}
	catch (...) {
		return -1;
	}
	sizew2 = wcstombs( d, a, sizew);
	d[sizew] = '\0';

	sizew = wcstombs( NULL, b, 0);
	if ( sizew == -1 ) {
		delete[] d;
		return -1;
	}
	try{
		e = new char[sizew+1];
	}
	catch (...) {
		delete[] d;
		return -1;
	}
	sizew2 = wcstombs( e, b, sizew);
	e[sizew] = '\0';

	ir = setenv(d, e, c);

	delete[] d;
	delete[] e;

	return ir;
}

//==============================================================================
//system̈ wchar_t* ɂbp[
//==============================================================================
int wsystem(wchar_t* a) {
	int ir;
	char *b;
	int sizew, sizew2;
	sizew = wcstombs( NULL, a, 0);
	if ( sizew == -1 ) return -1;
	try{
		b = new char[sizew+1];
	}
	catch (...) {
		return -1;
	}
	sizew2 = wcstombs( b, a, sizew);
	b[sizew] = '\0';

	ir = system(b);

	delete[] b;

	return ir;
}
#endif //_LINUX_PLAT

//==============================================================================
//t@Cf[^o
//==============================================================================
int GetProfileWrapp(int flag, UNICHAR *filename, UNICHAR *section, UNICHAR *key, UNICHAR *def, UNICHAR *data, int len) {
#ifdef _WINDOWS_PLAT
	if ( flag != 2 ) {
#ifdef _UNICODE_TABLE
		GetPrivateProfileStringW(section, key, def, data, len, filename);
#else  //_UNICODE_TABLE
		GetPrivateProfileStringA(section, key, def, data, len, filename);
#endif  //_UNICODE_TABLE
	}
	return 0;
#else  //_WINDOWS_PLAT
//t@C𕡐ɂ͊JȂ
//ȕ@`FbNĂȂ
	static UNICHAR *buf;
	static char *inbuf;
	static int Openflag;

	FILE *fp;
	static long filesize;
	int ia, ib, ic, id, ie;

	//̈
	if ( flag == 2 ) {
		if ( Openflag == 1 ) {
			delete [] buf;
			Openflag = 0;
		}
		filesize = 0;
		return 0;
	}

	//lݒ
	if ( MTRLEN(def) < len-1 ) {
		MTRCPY(data, len, def);
	} else {
		MTRNCPY(data, len, def, len);
		data[len] = LIT_NULL_C;
	}

	//t@C͂ė̈ɐݒ
	if ( flag == 0 ) {
#ifdef _UNICODE_TABLE
		fp = wfopen( filename, (wchar_t*)L"rb" );
#else  //_UNICODE_TABLE
		fp = fopen( filename, "rb" );
#endif  //_UNICODE_TABLE
		if( fp == NULL ){
			Openflag = 0;
			return -1;//t@CI[vG[
		}

		Openflag = 1;
		fseek( fp, 0, SEEK_END );
		filesize = ftell( fp );

		try{
			buf   = new UNICHAR[filesize+1];
			inbuf = new char[filesize+1];
		}
		catch (...) {
			fclose( fp );
			Openflag = 0;
			return -1;
		}
		fseek( fp, 0, SEEK_SET );
		if ( fread(inbuf, sizeof(char), filesize, fp) < filesize ) {
			MessageDisp( MSG_ER_INIR_CODE );
			fclose( fp );
			delete[] buf;
			delete[] inbuf;
			Openflag = 0;
			return -2;//t@C̓G[
		}
		inbuf[filesize] = '\0';

		fclose( fp );

#ifdef _UNICODE_TABLE
		int sizew2;
		sizew2 = mbstowcs( buf, inbuf, filesize);
		if ( sizew2 == -1 ) {//t@C̃R[he[us
			MessageDisp( MSG_ER_INIR_CODE );
			delete[] buf;
			delete[] inbuf;
			Openflag = 0;
			return -9;
		}
		buf[sizew2] = LIT_NULL_C;
#else  //_UNICODE_TABLE
		MTRCPY(buf, filesize+1, inbuf);
#endif  //_UNICODE_TABLE
		delete[] inbuf;

	}

	if ( Openflag == 0 ) {
		return -1;//t@CǂݍłȂG[
	}

	//L[T
	ib = 0;
	ic = 0;
	ie = 0;
	for(ia=0; ia<filesize-1; ia++) {
		if ( ie != 9 && MTRNCMP(&buf[ia], INI_KEYL, 1) == 0 ) {//[
			ib = 1;
		}
		if ( ib == 1 ) {
			if ( MTRNCMP(&buf[ia], INI_KEYR, 1) == 0 ) {//]
				ib = 0;
			}
			if ( MTRNCMP(&buf[ia], section, MTRLEN(section)) == 0 ) {
				ib = 2;
			}
		}
		if ( ib == 2 && MTRNCMP(&buf[ia], INI_KEYR, 1) == 0 ) {
			ib = 3;
		}
		if ( ie != 9 && ib == 3 ) {
			if ( MTRNCMP(&buf[ia], key, MTRLEN(key)) == 0 ) {
				ic = ia + MTRLEN(key);
				break;
			}
		}
		if ( buf[ia] == LIT_HCR || buf[ia] == LIT_HLF) {//CR-LF
			ie = 0;
			if ( buf[ia] == LIT_HCR && buf[ia+1] == LIT_HLF ) ia++;
			if ( buf[ia+1] == INI_COMMENT ) {
				ie = 9;
			}
		}
		ia = ia + ByteChk(buf[ia]);
	}
	if ( ic == 0 ) {
		return -3;//L[Ȃ
	}

	//f[^o
	ib = 0;
	for(ia=ic; ia<filesize; ia++) {
		if ( ib == 1 && MTRNCMP(&buf[ia], LIT_BLANK_S, 1) != 0 ) {
			ib = 2;
			id = ia;
		}
		if ( ib == 0 && MTRNCMP(&buf[ia], INI_EQL, 1) == 0 ) {
			ib = 1;
		}
		if ( ib == 2 && (buf[ia] == LIT_HCR || buf[ia] == LIT_HLF)) {//CR-LF
			if ( ia-id < len-1 ) {
				MTRNCPY(data, len, &buf[id], ia-id);
				data[ia-id] = LIT_NULL_C;
			} else {
				MTRNCPY(data, len, &buf[id], len);
				data[len] = LIT_NULL_C;
			}
			return 0;
		}
		ia = ia + ByteChk(buf[ia]);
	}
	return 0;
#endif  //_WINDOWS_PLAT
}

//==============================================================================
//Init@C珉lǂݍ
//==============================================================================
int ProfileGet(UNICHAR *Inifile) {
	UNICHAR wk[11];
	int irc;

	//ԕ\
	irc = GetProfileWrapp(0, Inifile, INI_KEY1, INI_TIME, INI_ON, wk, 10);
	if ( irc == -9 ) {
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
	TimeLog = 0;
	if ( MTRCMP(wk, INI_ON) == 0 ) TimeLog = 1;

	//o[W`FbN
	irc = GetProfileWrapp(1, Inifile, INI_KEY1A, INI_VERCHECK, INI_ON, wk, 10);
	if ( irc == -9 ) {
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
	VerChk = 1;
	if ( MTRCMP(wk, INI_ON) != 0 ) VerChk = 0;

	//l Windows
#ifdef _WINDOWS_PLAT
#ifdef _UNICODE_TABLE
	ClipWaitCount = GetPrivateProfileIntW(INI_KEY2, INI_CLIPWAITCOUNT, CLIP_WAITCOUNT, Inifile);
	ClipWaitTime  = GetPrivateProfileIntW(INI_KEY2, INI_CLIPWAITTIME, CLIP_WAITTIME, Inifile);
#ifdef _JPN
	AsciiWide     = GetPrivateProfileIntW(INI_KEY3, INI_ASCIIWIDE, CLIP_ASCIIWIDE, Inifile);
	HoriWide      = GetPrivateProfileIntW(INI_KEY3, INI_HORIWIDE, CLIP_HORIWIDE, Inifile);
#endif  //_JPN
#ifdef _ENG
	AsciiWide     = 1;
	HoriWide      = 2;
#endif  //_ENG
#else  //_UNICODE_TABLE
	ClipWaitCount = GetPrivateProfileIntA(INI_KEY2, INI_CLIPWAITCOUNT, CLIP_WAITCOUNT, Inifile);
	ClipWaitTime  = GetPrivateProfileIntA(INI_KEY2, INI_CLIPWAITTIME, CLIP_WAITTIME, Inifile);
#ifdef _JPN
	AsciiWide     = GetPrivateProfileIntA(INI_KEY3, INI_ASCIIWIDE, CLIP_ASCIIWIDE, Inifile);
	HoriWide      = GetPrivateProfileIntA(INI_KEY3, INI_HORIWIDE, CLIP_HORIWIDE, Inifile);
#endif  //_JPN
#ifdef _ENG
	AsciiWide     = 1;
	HoriWide      = 2;
#endif  //_ENG
#endif  //_UNICODE_TABLE

#else  //_WINDOWS_PLAT
	size_t sizew2;
	char wkc[101];

	//l Linux WaitCount
	irc = GetProfileWrapp(1, Inifile, INI_KEY2, INI_CLIPWAITCOUNT, CLIP_WAITCOUNT_S, wk, sizeof(wk));
#ifdef _UNICODE_TABLE
	sizew2 = wcstombs( wkc, wk, wcslen(wk));
	if ( sizew2 == -1 ) {
		MessageDisp( MSG_ER_INIR_CODE );
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
	wkc[sizew2] = LIT_NULL_C;
	ClipWaitCount = atoi(wkc);
#else  //_UNICODE_TABLE
	ClipWaitCount = atoi(wk);
#endif  //_UNICODE_TABLE
	if ( ClipWaitCount <= 0 ) ClipWaitCount = CLIP_WAITCOUNT;

	//l Linux WaitTime
	irc = GetProfileWrapp(1, Inifile, INI_KEY2, INI_CLIPWAITTIME, CLIP_WAITTIME_S, wk, sizeof(wk));
#ifdef _UNICODE_TABLE
	sizew2 = wcstombs( wkc, wk, wcslen(wk));
	if ( sizew2 == -1 ) {
		MessageDisp( MSG_ER_INIR_CODE );
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
	wkc[sizew2] = LIT_NULL_C;
	ClipWaitTime  = atoi(wkc);
#else  //_UNICODE_TABLE
	ClipWaitTime  = atoi(wk);
#endif  //_UNICODE_TABLE
	if ( ClipWaitTime <= 0 )  ClipWaitTime  = CLIP_WAITTIME;

#if defined(_JPN) || defined(_ENG)
	//l Linux AsciiWide
	irc = GetProfileWrapp(1, Inifile, INI_KEY3, INI_ASCIIWIDE, CLIP_ASCIIWIDE_S, wk, sizeof(wk));
#ifdef _UNICODE_TABLE
	sizew2 = wcstombs( wkc, wk, wcslen(wk));
	if ( sizew2 == -1 ) {
		MessageDisp( MSG_ER_INIR_CODE );
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
	wkc[sizew2] = LIT_NULL_C;
	AsciiWide   = atoi(wkc);
#else  //_UNICODE_TABLE
	AsciiWide   = atoi(wk);
#endif  //_UNICODE_TABLE
	if ( AsciiWide != 2 ) AsciiWide = CLIP_ASCIIWIDE;
#endif  //_JPN _ENG

#ifdef _JPN
	//l Linux HoriWide
	irc = GetProfileWrapp(1, Inifile, INI_KEY3, INI_HORIWIDE, CLIP_HORIWIDE_S, wk, sizeof(wk));
#ifdef _UNICODE_TABLE
	sizew2 = wcstombs( wkc, wk, wcslen(wk));
	if ( sizew2 == -1 ) {
		MessageDisp( MSG_ER_INIR_CODE );
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
	wkc[sizew2] = LIT_NULL_C;
	HoriWide  = atoi(wkc);
#else  //_UNICODE_TABLE
	HoriWide  = atoi(wk);
#endif  //_UNICODE_TABLE
	if ( HoriWide != 1 )  HoriWide  = CLIP_HORIWIDE;
#endif  //_JPN
#ifdef _ENG
	HoriWide      = 2;
#endif  //_ENG
#endif  //_WINDOWS_PLAT

#ifdef _SDK
	GetProfileWrapp(1, Inifile, INI_KEY4, INI_OFFICE_PATH,         LIT_NULL_S, SofficePath,        FILENAME_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY4, INI_RDB_PATH,            LIT_NULL_S, SofficeRdbPath,     FILENAME_SIZE);
	if ( (MTRCMP(SofficePath, LIT_NULL_S) == 0 && MTRCMP(SofficeRdbPath, LIT_NULL_S) != 0) ||
	     (MTRCMP(SofficePath, LIT_NULL_S) != 0 && MTRCMP(SofficeRdbPath, LIT_NULL_S) == 0) ) {
		MessageDisp( MSG_ER_INIP_CODE );
		GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
		return -9;
	}
#endif  //_SDK

#ifdef _WIKI
	int ia;
	UNICHAR work[100], work2[10];
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CNTL_CHAR,          INI_AT_S,   In_cntl_char,                       10);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_LINE_COLOR,         LIT_NULL_S, In_line_color_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_LINE_WIDTH,         LIT_NULL_S, In_line_width_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_BACK_COLOR,         LIT_NULL_S, In_back_color_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_COLOR,         LIT_NULL_S, In_font_color_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_SIZE,          LIT_NULL_S, In_font_size_wik.dt,          KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_BOLD,          LIT_NULL_S, In_font_bold_wik.dt,          KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_UNDERLINE,     LIT_NULL_S, In_font_underline_wik.dt,     KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_ITALIC,        LIT_NULL_S, In_font_italic_wik.dt,        KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_STRIKETHROUGH, LIT_NULL_S, In_font_strikethrough_wik.dt, KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSHR,         LIT_NULL_S, In_cell_poshr_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSHC,         LIT_NULL_S, In_cell_poshc_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSHL,         LIT_NULL_S, In_cell_poshl_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSVT,         LIT_NULL_S, In_cell_posvt_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSVC,         LIT_NULL_S, In_cell_posvc_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSVB,         LIT_NULL_S, In_cell_posvb_wik.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_SEP,           LIT_NULL_S, In_cell_sep_wik.dt,           KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_MRGH,          LIT_NULL_S, In_cell_mrgh_wik.dt,          KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_MRGV,          LIT_NULL_S, In_cell_mrgv_wik.dt,          KEY_SIZE);
	work2[1] = LIT_NULL_C;
	for(ia=0; ia<CHENGE_MAX; ia++) {
		work2[0] = ia + (int)'1';
		MTRCPY(work, sizeof(work), INI_CODE_CHENGE_M);
		MTRCAT(work, sizeof(work), work2);
		GetProfileWrapp(1, Inifile, INI_KEY3, work,     LIT_NULL_S, In_code_chenge_m_wik[ia].dt,     KEY_SIZE);
		MTRCPY(work, sizeof(work), INI_CODE_CHENGE_O);
		MTRCAT(work, sizeof(work), work2);
		GetProfileWrapp(1, Inifile, INI_KEY3, work,     LIT_NULL_S, In_code_chenge_o_wik[ia].dt,     KEY_SIZE);
		MTRCPY(work, sizeof(work), INI_CODE_CHENGE_R);
		MTRCAT(work, sizeof(work), work2);
		GetProfileWrapp(1, Inifile, INI_KEY3, work,     LIT_NULL_S, In_code_chenge_r_wik[ia].dt,     KEY_SIZE);
		if ( In_code_chenge_m_wik[ia].dt[0] == LIT_NULL_C ) {
			In_code_chenge_no = ia;
			break;
		}
	}
#endif  //_WIKI

#ifdef _HTML
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_HTMLVERSION,           INI_5_S,    In_html_version,             KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_TABLE_POSH,            LIT_NULL_S, In_table_posh.dt,            KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_TABLE_OUTLINE,         LIT_NULL_S, In_table_outline.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_LINE_COLOR_YN,         LIT_NULL_S, In_line_color_yn.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_LINE_WIDTH_YN,         LIT_NULL_S, In_line_width_yn.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_BACK_COLOR_YN,         LIT_NULL_S, In_back_color_yn.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_COLOR_YN,         LIT_NULL_S, In_font_color_yn.dt,         KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_SIZE_YN,          LIT_NULL_S, In_font_size_yn.dt,          KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_BOLD_YN,          LIT_NULL_S, In_font_bold_yn.dt,          KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_UNDERLINE_YN,     LIT_NULL_S, In_font_underline_yn.dt,     KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_ITALIC_YN,        LIT_NULL_S, In_font_italic_yn.dt,        KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_FONT_STRIKETHROUGH_YN, LIT_NULL_S, In_font_strikethrough_yn.dt, KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSH_YN,          LIT_NULL_S, In_cell_posh_yn.dt,          KEY_SIZE);
	GetProfileWrapp(1, Inifile, INI_KEY3, INI_CELL_POSV_YN,          LIT_NULL_S, In_cell_posv_yn.dt,          KEY_SIZE);
#endif  //_HTML

#ifdef _UNICODE_TABLE
	GetProfileWrapp(1, Inifile, INI_LOCALE, INI_LOCALE, LIT_NULL_S, Locale, sizeof(Locale));
#endif  //_UNICODE_TABLE

	GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);

	return NOMAL_RETURN;
}

//==============================================================================
//t@C邩ׂ
//==============================================================================
unsigned int FileSizeGet(UNICHAR *path_name, UNICHAR *file_name) {
//*path_name@@pX
//*file_name@@t@C
//߂l@1:@0:Ȃ@-1:tH_[I[vG[

#ifdef _WINDOWS_PLAT
	HANDLE hndl;
	UNICHAR workfile[FILENAME_SIZE];

	MTRCPY(workfile, sizeof(workfile), path_name);
	MTRCAT(workfile, sizeof(workfile), SEP_S);
	MTRCAT(workfile, sizeof(workfile), file_name);

#ifdef _UNICODE_TABLE
	WIN32_FIND_DATAW FindFileData;
	hndl = FindFirstFileW(workfile, &FindFileData);
#else  //_UNICODE_TABLE
	WIN32_FIND_DATA FindFileData;
	hndl = FindFirstFile(workfile, &FindFileData);
#endif  //_UNICODE_TABLE

//	hndl = FindFirstFileEx( file_name.c_str(),
//		FindExInfoStandard, &FindFileData, FindExSearchNameMatch, NULL, 0 );
	if ( hndl != INVALID_HANDLE_VALUE ) {
		if ( (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != FILE_ATTRIBUTE_DIRECTORY ) {
			return 1;
		} else {
			FindClose(hndl);
			return -1;
		}
	} else {
		return 0;
	}
//	return 0;
#else  //_WINDOWS_PLAT
	UNICHAR *filenamew;
	int sizew, sizew2;

	DIR *dp;
	struct dirent *p;

#ifdef _UNICODE_TABLE
	if ((dp = wopendir(path_name)) == NULL) return -1;
#else  //_UNICODE_TABLE
	if ((dp = opendir(path_name)) == NULL) return -1;
#endif  //_UNICODE_TABLE
	for (;;) {
		p = readdir(dp);
		if (p == NULL) break;
#ifdef _UNICODE_TABLE
		sizew = mbstowcs( NULL, p->d_name, 0);
		if ( sizew == -1 ) {
			closedir(dp);
			return -1;
		}
		try{
			filenamew = new UNICHAR[sizew+1];
		}
		catch (...) {
			closedir(dp);
			return -1;
		}
		sizew2 = mbstowcs( filenamew, p->d_name, sizew);
		filenamew[sizew] = LIT_NULL_C;
		if ( MTRCMP(filenamew, file_name) == 0 ) {
#else  //_UNICODE_TABLE
		if ( MTRCMP(p->d_name, file_name) == 0 ) {
#endif  //_UNICODE_TABLE
			closedir(dp);
			delete[] filenamew;
			return 1;
		}
		delete[] filenamew;
	}
	closedir(dp);
	return 0;
#endif  //_WINDOWS_PLAT
}


