//*****************************************************************************
//* Copyright (c) 2001-2011 Miday Workshop All rights reserved.
//*
//* File: MakeHtml.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#else  //_WINDOWS_PLAT
#include <stdint.h>
#endif  //_WINDOWS_PLAT
#include <stdio.h>
#include <string.h>
#include <wchar.h>

#ifdef _HTML

#include "ExcelDef.h"
#include "MakeHtml.h"
#include "FileIo.h"
#include "MsgLocale.h"

UNICHAR In_html_version[KEY_SIZE];
IN_PARM In_table_posh, In_table_outline, In_line_color_yn, In_line_width_yn, In_back_color_yn;
IN_PARM In_font_color_yn, In_font_size_yn, In_font_bold_yn, In_font_underline_yn;
IN_PARM In_font_italic_yn, In_font_strikethrough_yn, In_cell_posh_yn, In_cell_posv_yn;

typedef struct {
	UNICHAR b[KEY_SIZE];
	UNICHAR a[KEY_SIZE];
} CHAR_CONV;

#define CODECONV_NO 6
#ifdef _UNICODE_TABLE
CHAR_CONV codeconv[CODECONV_NO] = {{LIT_HTML_KEY_BR, LIT_HTML_TAG_BR},
                                   {LIT_HTML_KEY_BLK, LIT_HTML_KEY_AMP_BLK},
                                   {LIT_HTML_KEY_QUOT, LIT_HTML_KEY_AMP_QUOT},
                                   {LIT_HTML_KEY_AMP, LIT_HTML_KEY_AMP_AMP},
                                   {LIT_HTML_KEY_LT, LIT_HTML_KEY_AMP_LT},
                                   {LIT_HTML_KEY_GT, LIT_HTML_KEY_AMP_GT} };

UNICHAR cssparm[FONT_AT_NO][50] = { LIT_HTML_CSS_COLOR, LIT_HTML_CSS_FONT_SIZE,
                                    LIT_HTML_CSS_FONT_WEICHT, LIT_HTML_CSS_FONT_STYLE,
                                    LIT_HTML_CSS_UNDERLINE, LIT_HTML_CSS_LINE_THROUGT };
#else  //_UNICODE_TABLE
CHAR_CONV codeconv[CODECONV_NO] = {{LIT_HTML_KEY_BR, LIT_HTML_TAG_BR},
                                   {LIT_BLANK_S, LIT_HTML_KEY_AMP_BLK},
                                   {LIT_HTML_KEY_QUOT, LIT_HTML_KEY_AMP_QUOT},
                                   {LIT_HTML_KEY_AMP, LIT_HTML_KEY_AMP_AMP},
                                   {LIT_HTML_KEY_LT, LIT_HTML_KEY_AMP_LT},
                                   {LIT_HTML_KEY_GT, LIT_HTML_KEY_AMP_GT} };

char * cssparm[FONT_AT_NO] = { LIT_HTML_CSS_COLOR, LIT_HTML_CSS_FONT_SIZE,
                               LIT_HTML_CSS_FONT_WEICHT, LIT_HTML_CSS_FONT_STYLE,
                               LIT_HTML_CSS_UNDERLINE, LIT_HTML_CSS_LINE_THROUGT };
#endif  //_UNICODE_TABLE

//==============================================================================
//Z̓ꕶ
//==============================================================================
static int Cell_char_conv( CHAR_LEN old_data, CHAR_LEN *conv_data ) {
//    CHAR_LEN *old_data  ̓f[^
//    CHAR_LEN *conv_data o̓f[^
	int ia, ic, ix, flag;
	int len;

	flag = 0;
	conv_data->data[0] = LIT_NULL_C;
	for ( ic=0; ic<(int)MTRLEN(old_data.data); ic++ ) {
		switch(ByteChk(old_data.data[ic])) {
		case 1://VtgJIS EUC
			len = MTRLEN(conv_data->data);
			conv_data->data[len]   = old_data.data[ic];
			conv_data->data[len+1] = old_data.data[ic+1];
			conv_data->data[len+2] = LIT_NULL_C;
			ic++;
			continue;
		case 2://EUC
			len = MTRLEN(conv_data->data);
			conv_data->data[len]   = old_data.data[ic];
			conv_data->data[len+1] = old_data.data[ic+1];
			conv_data->data[len+2] = old_data.data[ic+2];
			conv_data->data[len+3] = LIT_NULL_C;
			ic = ic + 2;
			continue;
		}

		ix = 0;
		for(ia=0; ia<CODECONV_NO; ia++) {
			if ( MTRNCMP(&old_data.data[ic], codeconv[ia].b, MTRLEN(codeconv[ia].b)) == 0 ) {
				MTRCAT(conv_data->data, conv_data->size+1, codeconv[ia].a);
				ix = 1;
				if ( ia == 0 ) flag = 1;
			}
		}
		if ( ix == 0 ) {
			len = MTRLEN(conv_data->data);
			conv_data->data[len]   = old_data.data[ic];
			conv_data->data[len+1] = LIT_NULL_C;
		}

	}
	return flag;
}

//==============================================================================
//^RGB𕶎^ɕϊ
//==============================================================================
static void RGBChar(unsigned int intrgb, UNICHAR* charrgb) {
	unsigned int  red, green, blue;

	blue  = (intrgb & 0x00ff0000) >> 16;
	green = (intrgb & 0x0000ff00) >> 8;
	red   = (intrgb & 0x000000ff);
	SPRINTF(charrgb, 8, LIT_HTML_RGB, red, green, blue );
}

//==============================================================================
//Nbv{[hɏo͂f[^ҏW
//==============================================================================
int MakeData() {
#ifdef _WINDOWS_PLAT
	UNICHAR kaigyo[3] = { LIT_HCR, LIT_HLF, 0x00 };
#else  //_WINDOWS_PLAT
	UNICHAR kaigyo[2] = { LIT_HLF, 0x00 };
#endif  //_WINDOWS_PLAT

	int conv_flag, p_flag;
	int *font_attr, *cell_attr;
	UNICHAR ch_work[200];
	int iw, ih, ia, ib, ic, id, ie;

//------------------------------------------------------------------------------
//AR_FLAG == 1̘g̒𒲂ׂB
//------------------------------------------------------------------------------
	for ( ih=0; ih<Row_no; ih++ ) {
		for ( iw=0; iw<Col_no; iw++ ) {
			hyo[ih*Col_no+iw].merge[AR_WIDTH] = 0;
			if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 1 ) {
				hyo[ih*Col_no+iw].merge[AR_WIDTH] = hyo[ih*Col_no+iw].merge[AR_RIGHT] - hyo[ih*Col_no+iw].merge[AR_LEFT] + 1;
			}
		}
	}

	for ( ih=0; ih<Row_no; ih++ ) {
		for ( iw=0; iw<Col_no; iw++ ) {
			hyo[ih*Col_no+iw].merge[AR_HEIGHT] = 0;
			if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 1 ) {
				hyo[ih*Col_no+iw].merge[AR_HEIGHT] = hyo[ih*Col_no+iw].merge[AR_TOP] - hyo[ih*Col_no+iw].merge[AR_BOTTOM] + 1;
			}
		}
	}

//------------------------------------------------------------------------------
//𖄂ߍ
//------------------------------------------------------------------------------
	if ( CharLenNewAlloc(&out_wk_data, 10000) == MEMORY_ERROR ) {//ReAlloc͉ʂōsĂ
		FreeArea();
		return MEMORY_ERROR;
	}
	Out_wk_alloc = 1;

	if ( CharLenNewAlloc(&out_data, 10000) == MEMORY_ERROR ) {
		FreeArea();
		return MEMORY_ERROR;
	}
	Out_alloc = 1;

	p_flag = 0;
	out_data.data[0] = LIT_NULL_C;
	if ( MTRCMP(In_table_posh.dt, LIT_NULL_S) != 0 ) {
		MTRCPY(ch_work, sizeof(ch_work), LIT_HTML_KEY_LT);
		MTRCAT(ch_work, sizeof(ch_work), In_table_posh.dt);
		MTRCAT(ch_work, sizeof(ch_work), LIT_HTML_KEY_GT);
		if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
	}
	if ( CharLenCat(&out_data, LIT_HTML_TAG_TABLE_S) == MEMORY_ERROR ) return MEMORY_ERROR;
	if ( In_html_version[0] != LIT_HTML5_C ) {
		if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 ) {
			SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_BORDER_CELLSPACING, hyo[0].line[AR_TOP]);
		} else {
			SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_BORDER);
		}
		if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
//		if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 ) {
//			SPRINTF(ch_work, sizeof(ch_work), " BORDER=%d", hyo[0].line);
//			if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
//		}
		if ( MTRCMP(In_line_color_yn.dt, INI_ON) == 0 ) {
			if ( CharLenCat(&out_data, LIT_HTML_BORDERCOLOR) == MEMORY_ERROR ) return MEMORY_ERROR;
			RGBChar(hyo[0].lcolor[AR_TOP], ch_work);
			if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
		}
	} else {
		if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 || MTRCMP(In_line_color_yn.dt, INI_ON) == 0 ) {
			if ( CharLenCat(&out_data, LIT_HTML_CLS_T) == MEMORY_ERROR ) return MEMORY_ERROR;
		}
	}
	if ( CharLenCat(&out_data, LIT_HTML_KEY_GT_CAST) == MEMORY_ERROR ) return MEMORY_ERROR;

	try{
		font_attr = new int[Col_no*Row_no*(FONT_AT_NO+1)];
	}
	catch (...) {
		return MEMORY_ERROR;
	}
	font_attr_alloc = 1;
	font_attr_maxno = -1;
	memset(font_attr, 0, Col_no*Row_no*(FONT_AT_NO+1)*sizeof(int));
	try{
		cell_attr = new int[Col_no*Row_no*(CELL_AT_NO+1)];
	}
	catch (...) {
		return MEMORY_ERROR;
	}
	cell_attr_alloc = 1;
	cell_attr_maxno = -1;
	memset(cell_attr, 0, Col_no*Row_no*(CELL_AT_NO+1)*sizeof(int));
	for ( ih=0; ih<Row_no; ih++ ) {
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, LIT_HTML_TAG_TR_S) == MEMORY_ERROR ) return MEMORY_ERROR;
		for ( iw=0; iw<Col_no; iw++ ) {

			font_attr_maxno++;
			if ( In_html_version[0] == LIT_HTML5_C ) {
				if ( MTRCMP(In_font_underline_yn.dt, INI_ON) == 0 ) {
					if ( hyo[ih*Col_no+iw].underline != FONT_UNDERLINE_NONE ) { //
						font_attr[font_attr_maxno*FONT_AT_NO+FONT_AT_UNDERLINE] = 1;
					}
				}
			}

			//f[^̔ԍ𒲂ׂ
			ia = 0;
			font_attr_no = -1;
			for( ic=0; ic<FONT_AT_NO; ic++ ) {
				if ( font_attr[font_attr_maxno*FONT_AT_NO+ic] != 0 ) {
					ia = 1;
					break;
				}
			}
			if ( ia != 0 ) {
				if( font_attr_maxno != 0 ) {
					font_attr_no = font_attr_maxno;
					for( ib=0; ib<font_attr_maxno; ib++ ) {
						ia = 0;
						for( ic=0; ic<FONT_AT_NO; ic++ ) {
							if ( font_attr[ib*FONT_AT_NO+ic] != font_attr[font_attr_maxno*FONT_AT_NO+ic] ) {
								ia = 1;
								break;
							}
						}
						if ( ia == 0 ) {//SĂvꍇ
							font_attr_no = ib;
							font_attr_maxno--;
							break;
						}
					}
				} else {
					font_attr_no = 0;
				}
			} else {
				font_attr_maxno--;
			}

			cell_attr_maxno++;
			if ( In_html_version[0] == LIT_HTML5_C ) {
				if ( MTRCMP(In_back_color_yn.dt, INI_ON) == 0 ) {
					cell_attr[cell_attr_maxno*CELL_AT_NO+CELL_AT_BCOLOR] = hyo[ih*Col_no+iw].bcolor;
					cell_attr[cell_attr_maxno*CELL_AT_NO+CELL_AT_LCOLOR] = hyo[ih*Col_no+iw].lcolor[AR_TOP];
					if ( hyo[ih*Col_no+iw].line[AR_TOP] == 0 ) {
						cell_attr[cell_attr_maxno*CELL_AT_NO+CELL_AT_LCOLOR] = 0x00ffffff;//
					}
				}
			}

			//Zf[^̔ԍ𒲂ׂ
			ia = 0;
			cell_attr_no = -1;
//			for( ic=0; ic<CELL_AT_NO; ic++ ) {//gtׂɂǂ̃ZɂKv
//				if ( cell_attr[cell_attr_maxno*CELL_AT_NO+ic] != 0x00ffffff ) {//wiF
//					ia = 1;
//					break;
//				}
//			}
//			if ( ia != 0 ) {
				if( cell_attr_maxno != 0 ) {
					cell_attr_no = cell_attr_maxno;
					for( ib=0; ib<cell_attr_maxno; ib++ ) {
						ia = 0;
						for( ic=0; ic<CELL_AT_NO; ic++ ) {
							if ( cell_attr[ib*CELL_AT_NO+ic] != cell_attr[cell_attr_maxno*CELL_AT_NO+ic] ) {
								ia = 1;
								break;
							}
						}
						if ( ia == 0 ) {//SĂvꍇ
							cell_attr_no = ib;
							cell_attr_maxno--;
							break;
						}
					}
				} else {
					cell_attr_no = 0;
				}
//			} else {
//				cell_attr_maxno--;
//			}

			if( hyo[(ih)*Col_no+iw].merge[AR_FLAG] > 1 ) continue;

			if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
			if ( CharLenCat(&out_data, LIT_HTML_TAG_TD_S) == MEMORY_ERROR ) return MEMORY_ERROR;

			if( hyo[(ih)*Col_no+iw].merge[AR_FLAG] == 1 ) {
				if ( hyo[(ih)*Col_no+iw].merge[AR_WIDTH] >= 2 ) {
					SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_COLSPAN, hyo[(ih)*Col_no+iw].merge[AR_WIDTH] );
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if( hyo[(ih)*Col_no+iw].merge[AR_FLAG] == 1 ) {
				if ( hyo[(ih)*Col_no+iw].merge[AR_HEIGHT] >= 2 ) {
					SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_ROWSPAN, hyo[(ih)*Col_no+iw].merge[AR_HEIGHT] );
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( CharLenCat(&out_data, LIT_HTML_NOWRAP) == MEMORY_ERROR ) return MEMORY_ERROR;
			if ( MTRCMP(In_cell_posv_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].v_ichi == CELL_VERT_TOP ){
					if ( CharLenCat(&out_data, LIT_HTML_TOP) == MEMORY_ERROR ) return MEMORY_ERROR;
				} else if ( hyo[ih*Col_no+iw].v_ichi == CELL_VERT_BOTTOM ){
					if ( CharLenCat(&out_data, LIT_HTML_BOTTOM) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}

			if ( MTRCMP(In_back_color_yn.dt, INI_ON) == 0 ) {
				if ( In_html_version[0] != LIT_HTML5_C ) {
					if ( CharLenCat(&out_data, LIT_HTML_BGCOLOR) == MEMORY_ERROR ) return MEMORY_ERROR;
					RGBChar(hyo[ih*Col_no+iw].bcolor, ch_work);
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				} else {
					if ( cell_attr_no >= 0 ) {
						SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_CLS_C, cell_attr_no);
						if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
					}
				}
			}
			if ( CharLenCat(&out_data, LIT_HTML_KEY_GT_CAST) == MEMORY_ERROR ) return MEMORY_ERROR;

			//̐FƃTCY`
			if ( MTRCMP(In_font_color_yn.dt, INI_ON) == 0 ||
			     ( MTRCMP(In_font_size_yn.dt, INI_ON) == 0 && hyo[ih*Col_no+iw].size != 0 ) ) {
				if ( CharLenCat(&out_data, LIT_HTML_TAG_SPAN_S ) == MEMORY_ERROR ) return MEMORY_ERROR;
				if ( MTRCMP(In_font_size_yn.dt, INI_ON) == 0 && hyo[ih*Col_no+iw].size != 0 ) {
					SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_FONT_SIZE, hyo[ih*Col_no+iw].size );
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
				if ( MTRCMP(In_font_color_yn.dt, INI_ON) == 0 ||
				     ( MTRCMP(In_font_size_yn.dt, INI_ON) == 0 && hyo[ih*Col_no+iw].size != 0 ) ) {
					if ( CharLenCat(&out_data, LIT_HTML_KEY_SEMI ) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
				if ( MTRCMP(In_font_color_yn.dt, INI_ON) == 0 ) {
					if ( CharLenCat(&out_data, LIT_HTML_COLOR) == MEMORY_ERROR ) return MEMORY_ERROR;
					RGBChar(hyo[ih*Col_no+iw].fcolor, ch_work);
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
				if ( CharLenCat(&out_data, LIT_HTML_TAG_QUOTATION_END ) == MEMORY_ERROR ) return MEMORY_ERROR;
			}

			//̈ʒu`
			if ( MTRCMP(In_cell_posh_yn.dt, INI_ON) == 0 ) {
				switch ( hyo[ih*Col_no+iw].h_ichi ) {
				case CELL_HORI_RIGHT:
				case CELL_HORI_LEFT:
				case CELL_HORI_CENTER:
					break;
				default:
					if ( hyo[ih*Col_no+iw].num_flag == 1 ) hyo[ih*Col_no+iw].h_ichi = CELL_HORI_RIGHT;
					break;
				}
				if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_LEFT ){
					if ( CharLenCat(&out_data, LIT_HTML_TAG_P_LEFT) == MEMORY_ERROR ) return MEMORY_ERROR;
					p_flag = 1;
				} else if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_RIGHT ){
					if ( CharLenCat(&out_data, LIT_HTML_TAG_P_RIGHT) == MEMORY_ERROR ) return MEMORY_ERROR;
					p_flag = 1;
				} else if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_CENTER ){
					if ( CharLenCat(&out_data, LIT_HTML_TAG_P_CENTER) == MEMORY_ERROR ) return MEMORY_ERROR;
					p_flag = 1;
				}
//				if ( hyo[ih*Col_no+iw].h_ichi == xlCenterAcrossSelection ){
//				}
			}

			//̃NX`
			if ( font_attr_no != -1 ) {//html5
				if ( p_flag == 0 ) {
					if ( CharLenCat(&out_data, LIT_HTML_TAG_P_S) == MEMORY_ERROR ) return MEMORY_ERROR;
					p_flag = 1;
				}
				if ( font_attr_no >= 0 ) {
					SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_CLS_F, font_attr_no);
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( p_flag != 0 ) {
				if ( CharLenCat(&out_data, LIT_HTML_KEY_GT_CAST) == MEMORY_ERROR ) return MEMORY_ERROR;
			}

			if ( MTRCMP(In_font_bold_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].bold ) { //
					if ( CharLenCat(&out_data, LIT_HTML_TAG_B_S) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( MTRCMP(In_font_underline_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].underline != FONT_UNDERLINE_NONE ) { //
					if ( In_html_version[0] != LIT_HTML5_C ) {
						if ( CharLenCat(&out_data, LIT_HTML_TAG_U_S) == MEMORY_ERROR ) return MEMORY_ERROR;
					}
				}
			}
			if ( MTRCMP(In_font_italic_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].italic ) { //Α
					if ( CharLenCat(&out_data, LIT_HTML_TAG_I_S) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( MTRCMP(In_font_strikethrough_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].strikethrough != 0 ) { //
					if ( CharLenCat(&out_data, LIT_HTML_TAG_S_S) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}

			//`
			if ( hyo[ih*Col_no+iw].text.size > 0 ) {
				if ( hyo[ih*Col_no+iw].text.data[0] != LIT_NULL_C ||
				     hyo[ih*Col_no+iw].text.data[0] != LIT_HCR ||
				     hyo[ih*Col_no+iw].text.data[0] != LIT_HLF ||
				     hyo[ih*Col_no+iw].text.data[0] != LIT_TAB_C ) {
					conv_flag = Cell_char_conv( hyo[ih*Col_no+iw].text, &out_wk_data );
					if ( CharLenCat(&out_data, out_wk_data.data) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}

			//㏈svȑ
			//	wiF@F@@cʒu
			if ( MTRCMP(In_font_strikethrough_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].strikethrough != 0 ) { //
					if ( CharLenCat(&out_data, LIT_HTML_TAG_S_E) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( MTRCMP(In_font_italic_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].italic ) { //Α
					if ( CharLenCat(&out_data, LIT_HTML_TAG_I_E) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( MTRCMP(In_font_underline_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].underline != FONT_UNDERLINE_NONE ) { //
					if ( In_html_version[0] != LIT_HTML5_C ) {
						if ( CharLenCat(&out_data, LIT_HTML_TAG_U_E) == MEMORY_ERROR ) return MEMORY_ERROR;
					}
				}
			}
			if ( MTRCMP(In_font_bold_yn.dt, INI_ON) == 0 ) {
				if ( hyo[ih*Col_no+iw].bold ) { //
					if ( CharLenCat(&out_data, LIT_HTML_TAG_B_E) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}
			if ( p_flag != 0 ) {
				if ( CharLenCat(&out_data, LIT_HTML_TAG_P_E) == MEMORY_ERROR ) return MEMORY_ERROR;//html5
				p_flag = 0;
			}
			if ( MTRCMP(In_font_color_yn.dt, INI_ON) == 0 ||
			     ( MTRCMP(In_font_size_yn.dt, INI_ON) == 0 && hyo[ih*Col_no+iw].size != 0 ) ) {
				if ( CharLenCat(&out_data, LIT_HTML_TAG_SPAN_E) == MEMORY_ERROR ) return MEMORY_ERROR;
			}

			if ( CharLenCat(&out_data, LIT_HTML_TAG_TD_E) == MEMORY_ERROR ) return MEMORY_ERROR;
		}
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, LIT_HTML_TAG_TR_E) == MEMORY_ERROR ) return MEMORY_ERROR;
	}
	if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
	if ( CharLenCat(&out_data, LIT_HTML_TAG_TABLE_E) == MEMORY_ERROR ) return MEMORY_ERROR;

	//CSS쐬
	if ( In_html_version[0] == LIT_HTML5_C ) {
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, LIT_HTML_TAG_STYLE_S) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, LIT_HTML_TAG_COM_S) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;

		//r
		if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 || MTRCMP(In_line_color_yn.dt, INI_ON) == 0 ) {
			if ( CharLenCat(&out_data, LIT_HTML_PARM_T) == MEMORY_ERROR ) return MEMORY_ERROR;
			if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 ) {
				SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_DPX, hyo[0].line[AR_TOP]);
				if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
			}
			if ( MTRCMP(In_line_color_yn.dt, INI_ON) == 0 ) {
				if ( MTRCMP(In_table_outline.dt, LIT_NULL_S) != 0 ) {
					MTRCPY( ch_work, sizeof(ch_work), In_table_outline.dt );
				} else {
					RGBChar(hyo[0].lcolor[AR_TOP], ch_work);
				}
				if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				if ( CharLenCat(&out_data, LIT_BLANK_S) == MEMORY_ERROR ) return MEMORY_ERROR;
			}
			if ( CharLenCat(&out_data, LIT_HTML_SOLID) == MEMORY_ERROR ) return MEMORY_ERROR;
			if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		}

		//
		for( ib=0; ib<=font_attr_maxno; ib++ ) {
			SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_PARM_F, ib);
			if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
			id = 0;
			ie = 0;

			for( ic=0; ic<FONT_AT_NO; ic++ ) {
				if ( font_attr[ib*FONT_AT_NO+ic] == 1 ) {
					if ( id == 1 ) {
						if ( CharLenCat(&out_data, LIT_HTML_KEY_SEMI) == MEMORY_ERROR ) return MEMORY_ERROR;
					}
					id = 1;
					switch(ic) {//html5pɑȌ̕CSS쐬Ă͉̂ł(͏p)
					case FONT_AT_COLOR:
						if ( CharLenCat(&out_data, cssparm[ic]) == MEMORY_ERROR ) return MEMORY_ERROR;
						RGBChar(font_attr[ib*FONT_AT_NO+ic], ch_work);
						if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
						break;
					case FONT_AT_SIZE:
						SPRINTF(ch_work, sizeof(ch_work), cssparm[ic], font_attr[ib*FONT_AT_NO+ic]);
						if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
						break;
					case FONT_AT_BOLD:
					case FONT_AT_ITALIC:
						if ( CharLenCat(&out_data, cssparm[ic]) == MEMORY_ERROR ) return MEMORY_ERROR;
						break;
					case FONT_AT_UNDERLINE:
					case FONT_AT_STRIKETHROUGH:
						if ( ie == 0 ) {
							if ( CharLenCat(&out_data, LIT_HTML_TEXT_DECO) == MEMORY_ERROR ) return MEMORY_ERROR;
						}
						if ( CharLenCat(&out_data, cssparm[ic]) == MEMORY_ERROR ) return MEMORY_ERROR;
						ie = 1;
						break;
					}
				}
			}

			if ( id == 1 ) {
				if ( CharLenCat(&out_data, LIT_HTML_KEY_RIGHT_CURLY) == MEMORY_ERROR ) return MEMORY_ERROR;
				if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
			}
		}

		//Z
		for( ib=0; ib<=cell_attr_maxno; ib++ ) {
			SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_PARM_C, ib);
			if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
			id = 0;
			ie = 0;

			if ( MTRCMP(In_back_color_yn.dt, INI_ON) == 0 ) {
				if ( CharLenCat(&out_data, LIT_HTML_BACK_COLOR) == MEMORY_ERROR ) return MEMORY_ERROR;
				RGBChar(cell_attr[ib*CELL_AT_NO+CELL_AT_BCOLOR], ch_work);
				if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				id = 1;
			}

			//Žr
			if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 || MTRCMP(In_line_color_yn.dt, INI_ON) == 0 ) {
				if ( id == 1 ) {
					if ( CharLenCat(&out_data, LIT_HTML_KEY_SEMI) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
				if ( CharLenCat(&out_data, LIT_HTML_BORDER_C) == MEMORY_ERROR ) return MEMORY_ERROR;
				if ( MTRCMP(In_line_width_yn.dt, INI_ON) == 0 ) {
					SPRINTF(ch_work, sizeof(ch_work), LIT_HTML_DPX, hyo[0].line[AR_TOP]);
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
				if ( MTRCMP(In_line_color_yn.dt, INI_ON) == 0 ) {
					RGBChar(cell_attr[ib*CELL_AT_NO+CELL_AT_LCOLOR], ch_work);
					if ( CharLenCat(&out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
					if ( CharLenCat(&out_data, LIT_BLANK_S) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
				if ( CharLenCat(&out_data, LIT_HTML_SOLID) == MEMORY_ERROR ) return MEMORY_ERROR;
				if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
			}
		}

		if ( CharLenCat(&out_data, LIT_HTML_TAG_COM_E) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, LIT_HTML_TAG_STYLE_E) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
	}
//printf("OUT %lsEND\n", out_data.data);

	return NOMAL_RETURN;
}
#endif  //_HTML
