//*****************************************************************************
//* Copyright (c) 2001-2011 Miday Workshop All rights reserved.
//*
//* File: MakeWiki.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#else  //_WINDOWS_PLAT
#include <stdint.h>
#endif  //_WINDOWS_PLAT
#include <stdio.h>
#include <string.h>
#include <wchar.h>

#ifdef _WIKI

#include "ExcelDef.h"
#include "MakeWiki.h"
#include "MsgLocale.h"

#define KEY_SEP_POS 0
#define KEY_EXIS1   1
#define KEY_EXIS2   2
#define KEY_CODENO1 3
#define KEY_CODENO2 4

#define BEFORE 0
#define AFTER  1

UNICHAR In_cntl_char[10];
IN_PARM In_line_color_wik, In_line_width_wik, In_back_color_wik, In_font_color_wik, In_font_size_wik;
IN_PARM In_font_bold_wik, In_font_underline_wik, In_font_italic_wik, In_font_strikethrough_wik;
IN_PARM In_cell_poshr_wik, In_cell_poshc_wik, In_cell_poshl_wik, In_cell_posvt_wik, In_cell_posvc_wik, In_cell_posvb_wik, In_cell_sep_wik, In_cell_mrgh_wik;
IN_PARM In_cell_mrgv_wik, In_code_chenge_m_wik[CHENGE_MAX], In_code_chenge_o_wik[CHENGE_MAX], In_code_chenge_r_wik[CHENGE_MAX];
int In_code_chenge_no;

//==============================================================================
//Z̓ꕶ
//==============================================================================
static int Cell_char_conv( CHAR_LEN old_data, CHAR_LEN *conv_data ) {
//    CHAR_LEN *old_data  ̓f[^
//    CHAR_LEN *conv_data o̓f[^
	int ia, ib, ic, ix, iy;
	int len, irc;
	int iy2[CHENGE_MAX];
	CHAR_LEN work_data;

	iy = 0;
	for(ia=0; ia<In_code_chenge_no; ia++) {
		iy2[ia] = 0;
	}
	conv_data->data[0] = LIT_NULL_C;
	for ( ic=0; ic<(int)MTRLEN(old_data.data); ic++ ) {
		switch(ByteChk(old_data.data[ic])) {
		case 1://VtgJIS EUC
			len = MTRLEN(conv_data->data);
			conv_data->data[len]   = old_data.data[ic];
			conv_data->data[len+1] = old_data.data[ic+1];
			conv_data->data[len+2] = LIT_NULL_C;
			ic++;
			continue;
		case 2://EUC
			len = MTRLEN(conv_data->data);
			conv_data->data[len]   = old_data.data[ic];
			conv_data->data[len+1] = old_data.data[ic+1];
			conv_data->data[len+2] = old_data.data[ic+2];
			conv_data->data[len+3] = LIT_NULL_C;
			ic = ic + 2;
			continue;
		}

		ix = 0;
		for(ia=0; ia<In_code_chenge_no; ia++) {
			if ( MTRNCMP(&old_data.data[ic], In_code_chenge_m_wik[ia].dt, MTRLEN(In_code_chenge_m_wik[ia].dt)) == 0 ) {
				if ( MTRCMP(In_code_chenge_r_wik[ia].dt, LIT_WIKI_ALL) != 0 ) {
					MTRCAT(conv_data->data, conv_data->size+1, In_code_chenge_o_wik[ia].dt);
					ix      = 1;
				} else {
					iy      = 1;
					iy2[ia] = 1;
				}
			}
		}
		if ( ix == 0 ) {
			len = MTRLEN(conv_data->data);
			conv_data->data[len]   = old_data.data[ic];
			conv_data->data[len+1] = LIT_NULL_C;
		}
	}

	if ( iy == 1 ) {
		//dO
		for(ia=0; ia<In_code_chenge_no-1; ia++) {
			for(ib=ia+1; ib<In_code_chenge_no; ib++) {
				if ( ia == ib ) continue;
				if ( iy2[ia] == 1 && iy2[ib] == 1 ) {
					if ( MTRCMP(In_code_chenge_o_wik[ia].dt, In_code_chenge_o_wik[ib].dt) == 0 ) {
						iy2[ib] = 0;
					}
				}
			}
		}
		//[ɕt
		for(ia=0; ia<In_code_chenge_no; ia++) {
			if ( iy2[ia] == 1 ) {
				if ( CharLenNewAlloc(&work_data, MTRLEN(conv_data->data)+KEY_SIZE * 2) == MEMORY_ERROR ) {
					irc = MessageDisp( MSG_ER_MEM3_CODE );
					return MEMORY_ERROR;
				}
				MTRCPY(work_data.data, work_data.size+1, In_code_chenge_o_wik[ia].dt);
				MTRCAT(work_data.data, work_data.size+1, conv_data->data);
				MTRCAT(work_data.data, work_data.size+1, In_code_chenge_o_wik[ia].dt);
				conv_data->data[0] = LIT_NULL_C;
				if ( CharLenCat(conv_data, work_data.data) == MEMORY_ERROR ) return MEMORY_ERROR;
				CharLenFree(&work_data);
			}
		}
	}
	return 0;
}

//==============================================================================
//L[𕪊ҏW
//==============================================================================
static void KeySep(IN_PARM* key, UNICHAR* cntl_char) {
	int ia, ib, ix;
	ix = (int)MTRLEN(key->dt);
	if ( ix == 0 ) {
		key->it[KEY_SEP_POS] = 0;
		key->it[KEY_EXIS1]   = 0;
		key->it[KEY_EXIS2]   = 0;
		key->it[KEY_CODENO1] = 0;
		key->it[KEY_CODENO2] = 0;
		return;
	}
	key->it[KEY_EXIS1] = 1;
	key->it[KEY_EXIS2] = 1;
	for(ia=0; ia<ix; ia++) {
		if ( key->dt[ia] == *cntl_char) {
			key->dt[ia] = LIT_NULL_C;
			key->it[KEY_SEP_POS] = ia + 1;
			if ( ia == 0 ) {
				key->it[KEY_EXIS1] = 0;
			}
			if ( ia == ix-1 ) {
				key->it[KEY_EXIS2] = 0;
			}

			key->it[KEY_CODENO1] = 0;
			for(ib=0; ib<key->it[KEY_SEP_POS]; ib++) {//"%c" "%s" ͌؂ĂȂ
				if ( MTRNCMP(&key->dt[ib], LIT_WIKI_PD, 2 ) == 0 || MTRNCMP(&key->dt[ib], LIT_WIKI_PC, 2 ) == 0 ||
				     MTRNCMP(&key->dt[ib], LIT_WIKI_PS, 2 ) == 0 || MTRNCMP(&key->dt[ib], LIT_WIKI_PX, 2 ) == 0 ) {
					key->it[KEY_CODENO1]++;
				}
			}
			key->it[KEY_CODENO2] = 0;
			for(ib=key->it[KEY_SEP_POS]+1; ib<ix; ib++) {
				if ( MTRNCMP(&key->dt[ib], LIT_WIKI_PD, 2 ) == 0 || MTRNCMP(&key->dt[ib], LIT_WIKI_PC, 2 ) == 0 ||
				     MTRNCMP(&key->dt[ib], LIT_WIKI_PS, 2 ) == 0 || MTRNCMP(&key->dt[ib], LIT_WIKI_PX, 2 ) == 0 ) {
					key->it[KEY_CODENO2]++;
				}
			}

			return;
		}
	}
	key->it[KEY_SEP_POS] = ix - 1;
	key->it[KEY_EXIS2]   = 0;

	key->it[KEY_CODENO1] = 0;
	for(ib=0; ib<key->it[KEY_SEP_POS]; ib++) {
		if ( MTRNCMP(&key->dt[ib], LIT_WIKI_PD, 2 ) == 0 || MTRNCMP(&key->dt[ib], LIT_WIKI_PC, 2 ) == 0 ||
		     MTRNCMP(&key->dt[ib], LIT_WIKI_PS, 2 ) == 0 || MTRNCMP(&key->dt[ib], LIT_WIKI_PX, 2 ) == 0 ) {
			key->it[KEY_CODENO1]++;
		}
	}
	key->it[KEY_CODENO2] = 0;

	return;
}

//==============================================================================
//^RGB𕶎^ɕϊ
//==============================================================================
static void RGBChar(unsigned int intrgb, UNICHAR* charrgb) {
	unsigned int  red, green, blue;

	blue  = (intrgb & 0x00ff0000) >> 16;
	green = (intrgb & 0x0000ff00) >> 8;
	red   = (intrgb & 0x000000ff);
	SPRINTF(charrgb, 8, LIT_WIKI_RGB, red, green, blue );
}

//==============================================================================
//f[^쐬
//==============================================================================
static int MakeAttr(IN_PARM key, int form_flag, UNICHAR* word, CHAR_LEN* out_data, int baflag) {
//form_flag=0()̏ꍇ̏
	int pos, ia;

	if ( baflag == BEFORE ) {
		pos = 0;
		ia  = 0;
	} else {
		pos = key.it[KEY_SEP_POS];
		ia  = 1;
	}

	if ( CharLenCat(out_data, &key.dt[pos]) == MEMORY_ERROR ) return MEMORY_ERROR;
	return 0;
}

static int MakeAttr(IN_PARM key, int form_flag, const int word, CHAR_LEN* out_data, int baflag) {
//form_flag=1(l)
//form_flag=2(FR[h)
	int pos, ia;
	UNICHAR ch_work[200], ch_workc[2000];

	if ( baflag == BEFORE ) {
		pos = 0;
		ia  = 0;
	} else {
		pos = key.it[KEY_SEP_POS];
		ia  = 1;
	}

	if ( key.it[KEY_EXIS1+ia] != 0 ) {
		if ( key.it[KEY_CODENO1+ia] != 0 ) {
			if ( form_flag == 2 ) {//F@%x@̏
//#ifdef _GTK_BIT32  //gtk64 long=8byte  gtk32 ling=4byte
//				RGBChar((unsigned int)word, ch_workc);
//#else //_GTK_BIT32
				RGBChar((unsigned long)word, ch_workc);
//#endif //_GTK_BIT32
				SPRINTF(ch_work, sizeof(ch_work), &key.dt[pos], ch_workc );
			} else {//FȊȎf[^@%d@̂݃eXgς
				SPRINTF(ch_work, sizeof(ch_work), &key.dt[pos], word );
			}
			if ( CharLenCat(out_data, ch_work) == MEMORY_ERROR ) return MEMORY_ERROR;
		} else {
			if ( CharLenCat(out_data, &key.dt[pos]) == MEMORY_ERROR ) return MEMORY_ERROR;
		}
	}
	return 0;
}

//==============================================================================
//Nbv{[hɏo͂f[^ҏW
//==============================================================================
int MakeData() {
#ifdef _WINDOWS_PLAT
	UNICHAR kaigyo[3] = { LIT_HCR, LIT_HLF, 0x00 };
#else  //_WINDOWS_PLAT
	UNICHAR kaigyo[2] = { LIT_HLF, 0x00 };
#endif  //_WINDOWS_PLAT

	int conv_flag;
	int iw, ih, ia;

//------------------------------------------------------------------------------
//ϊL[̕ҏW
//------------------------------------------------------------------------------
	KeySep(&In_line_color_wik,         In_cntl_char);
	KeySep(&In_line_width_wik,         In_cntl_char);
	KeySep(&In_back_color_wik,         In_cntl_char);
	KeySep(&In_font_color_wik,         In_cntl_char);
	KeySep(&In_font_size_wik,          In_cntl_char);
	KeySep(&In_font_bold_wik,          In_cntl_char);
	KeySep(&In_font_underline_wik,     In_cntl_char);
	KeySep(&In_font_italic_wik,        In_cntl_char);
	KeySep(&In_font_strikethrough_wik, In_cntl_char);
	KeySep(&In_cell_poshr_wik,         In_cntl_char);
	KeySep(&In_cell_poshc_wik,         In_cntl_char);
	KeySep(&In_cell_poshl_wik,         In_cntl_char);
	KeySep(&In_cell_posvt_wik,         In_cntl_char);
	KeySep(&In_cell_posvc_wik,         In_cntl_char);
	KeySep(&In_cell_posvb_wik,         In_cntl_char);
	KeySep(&In_cell_sep_wik,           In_cntl_char);
	KeySep(&In_cell_mrgh_wik,          In_cntl_char);
	KeySep(&In_cell_mrgv_wik,          In_cntl_char);
	for(ia=0; ia<In_code_chenge_no; ia++) {
		KeySep(&In_code_chenge_m_wik[ia],   In_cntl_char);
		KeySep(&In_code_chenge_o_wik[ia],   In_cntl_char);
		KeySep(&In_code_chenge_r_wik[ia],   In_cntl_char);
	}

//------------------------------------------------------------------------------
//AR_FLAG == 1̘g̒𒲂ׂB
//------------------------------------------------------------------------------
	for ( ih=0; ih<Row_no; ih++ ) {
		for ( iw=0; iw<Col_no; iw++ ) {
			hyo[ih*Col_no+iw].merge[AR_WIDTH] = 0;
			if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 1 ) {
				hyo[ih*Col_no+iw].merge[AR_WIDTH] = hyo[ih*Col_no+iw].merge[AR_RIGHT] - hyo[ih*Col_no+iw].merge[AR_LEFT] + 1;
			}
		}
	}

	for ( ih=0; ih<Row_no; ih++ ) {
		for ( iw=0; iw<Col_no; iw++ ) {
			hyo[ih*Col_no+iw].merge[AR_HEIGHT] = 0;
			if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 1 ) {
				hyo[ih*Col_no+iw].merge[AR_HEIGHT] = hyo[ih*Col_no+iw].merge[AR_TOP] - hyo[ih*Col_no+iw].merge[AR_BOTTOM] + 1;
			}
		}
	}

//------------------------------------------------------------------------------
//𖄂ߍ
//------------------------------------------------------------------------------
	if ( CharLenNewAlloc(&out_wk_data, 10000) == MEMORY_ERROR ) {//ReAlloc͉ʂōsĂ
		FreeArea();
		return MEMORY_ERROR;
	}
	Out_wk_alloc = 1;

	if ( CharLenNewAlloc(&out_data, 10000) == MEMORY_ERROR ) {
		FreeArea();
		return MEMORY_ERROR;
	}
	Out_alloc = 1;

	out_data.data[0] = LIT_NULL_C;
	if ( MakeAttr(In_line_color_wik, 2, hyo[0].lcolor[AR_TOP], &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
	if ( hyo[0].line[AR_TOP] != 0  ) {
		if ( MakeAttr(In_line_width_wik, 1, hyo[0].line[AR_TOP], &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
	}

	for ( ih=0; ih<Row_no; ih++ ) {
		for ( iw=0; iw<Col_no; iw++ ) {

			if( hyo[(ih)*Col_no+iw].merge[AR_FLAG] > 1 ) continue;

			if ( CharLenCat(&out_data, In_cell_sep_wik.dt) == MEMORY_ERROR ) return MEMORY_ERROR;

			if ( hyo[(ih)*Col_no+iw].merge[AR_FLAG] == 1 ) {
				for(ia=0; ia<hyo[(ih)*Col_no+iw].merge[AR_HEIGHT]; ia++) {
					if ( MakeAttr(In_cell_mrgv_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
				}
				for(ia=0; ia<hyo[(ih)*Col_no+iw].merge[AR_WIDTH]; ia++) {
					if ( MakeAttr(In_cell_mrgh_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
				}
			}
			if ( hyo[ih*Col_no+iw].v_ichi == CELL_VERT_TOP ) {
				if ( MakeAttr(In_cell_posvt_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			} else if ( hyo[ih*Col_no+iw].v_ichi == CELL_VERT_CENTER ) {
				if ( MakeAttr(In_cell_posvc_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			} else {
				if ( MakeAttr(In_cell_posvb_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			}

			//wiF
			if ( MakeAttr(In_back_color_wik, 2, hyo[ih*Col_no+iw].bcolor, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;

			//̐F
			if ( MakeAttr(In_font_color_wik, 2, hyo[ih*Col_no+iw].fcolor, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			//̑傫
			if ( MakeAttr(In_font_size_wik, 1, hyo[ih*Col_no+iw].size, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;

			switch ( hyo[ih*Col_no+iw].h_ichi ) {
			case CELL_HORI_RIGHT:
			case CELL_HORI_LEFT:
			case CELL_HORI_CENTER:
				break;
			default:
				if ( hyo[ih*Col_no+iw].num_flag == 1 ) hyo[ih*Col_no+iw].h_ichi = CELL_HORI_RIGHT;
				break;
			}

			if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_RIGHT ) {//ʒu
				if ( MakeAttr(In_cell_poshr_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			} else if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_CENTER ) {
				if ( MakeAttr(In_cell_poshc_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			} else {
				if ( MakeAttr(In_cell_poshl_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			}
//			else if ( hyo[ih*Col_no+iw].h_ichi == xlCenterAcrossSelection ){
//			}
			if ( hyo[ih*Col_no+iw].bold ) { //
				if ( MakeAttr(In_font_bold_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[ih*Col_no+iw].underline != FONT_UNDERLINE_NONE ) { //
				if ( MakeAttr(In_font_underline_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[ih*Col_no+iw].italic ) { //Α
				if ( MakeAttr(In_font_italic_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[ih*Col_no+iw].strikethrough != 0 ) { //
				if ( MakeAttr(In_font_strikethrough_wik, 0, LIT_NULL_S, &out_data, BEFORE) != 0 ) return MEMORY_ERROR;
			}

			//`
			if ( hyo[ih*Col_no+iw].text.size > 0 ) {
				if ( hyo[ih*Col_no+iw].text.data[0] != LIT_NULL_C ||
				     hyo[ih*Col_no+iw].text.data[0] != LIT_HCR ||
				     hyo[ih*Col_no+iw].text.data[0] != LIT_HLF ||
				     hyo[ih*Col_no+iw].text.data[0] != LIT_TAB_C ) {
					conv_flag = Cell_char_conv( hyo[ih*Col_no+iw].text, &out_wk_data );
					if ( CharLenCat(&out_data, out_wk_data.data) == MEMORY_ERROR ) return MEMORY_ERROR;
				}
			}

			if ( hyo[ih*Col_no+iw].strikethrough != 0 ) { //
				if ( MakeAttr(In_font_strikethrough_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[ih*Col_no+iw].italic ) { //Α
				if ( MakeAttr(In_font_italic_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[ih*Col_no+iw].underline != FONT_UNDERLINE_NONE ) { //
				if ( MakeAttr(In_font_underline_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[ih*Col_no+iw].bold ) { //
				if ( MakeAttr(In_font_bold_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			}

			if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_LEFT ) {
				if ( MakeAttr(In_cell_poshl_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			} else if ( hyo[ih*Col_no+iw].h_ichi == CELL_HORI_CENTER ) {
				if ( MakeAttr(In_cell_poshc_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			} else {
				if ( MakeAttr(In_cell_poshr_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			}

			//̑傫
			if ( MakeAttr(In_font_size_wik, 1, hyo[ih*Col_no+iw].size, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			//̐F
			if ( MakeAttr(In_font_color_wik, 2, hyo[ih*Col_no+iw].fcolor, &out_data, AFTER) != 0 ) return MEMORY_ERROR;

			//wiF
			if ( MakeAttr(In_back_color_wik, 2, hyo[ih*Col_no+iw].bcolor, &out_data, AFTER) != 0 ) return MEMORY_ERROR;

			if ( hyo[ih*Col_no+iw].v_ichi == CELL_VERT_BOTTOM ) {
				if ( MakeAttr(In_cell_posvb_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			} else if ( hyo[ih*Col_no+iw].v_ichi == CELL_VERT_CENTER ) {
				if ( MakeAttr(In_cell_posvc_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			} else {
				if ( MakeAttr(In_cell_posvt_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
			}
			if ( hyo[(ih)*Col_no+iw].merge[AR_FLAG] == 1 ) {
				for(ia=0; ia<hyo[(ih)*Col_no+iw].merge[AR_WIDTH]; ia++) {
					if ( MakeAttr(In_cell_mrgh_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
				}
				for(ia=0; ia<hyo[(ih)*Col_no+iw].merge[AR_HEIGHT]; ia++) {
					if ( MakeAttr(In_cell_mrgv_wik, 0, LIT_NULL_S, &out_data, AFTER) != 0 ) return MEMORY_ERROR;
				}
			}
		}
		if ( CharLenCat(&out_data, In_cell_sep_wik.dt) == MEMORY_ERROR ) return MEMORY_ERROR;
		if ( CharLenCat(&out_data, kaigyo) == MEMORY_ERROR ) return MEMORY_ERROR;
	}
	if ( hyo[0].line[AR_TOP] != 0  ) {
		if ( MakeAttr(In_line_width_wik, 1, hyo[0].line[AR_TOP], &out_data, AFTER) != 0 ) return MEMORY_ERROR;
	}
	if ( MakeAttr(In_line_color_wik, 2, hyo[0].lcolor[AR_TOP], &out_data, AFTER) != 0 ) return MEMORY_ERROR;

	return NOMAL_RETURN;
}
#endif  //_WIKI
