//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: MsgDisp.cpp
//*****************************************************************************

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "ExcelDef.h"
#include "MsgLocale.h"

//==============================================================================
//bZ[W\
//==============================================================================
int MessageDisp(int msg_no) {
	unsigned int style;
	int result;
	const char *msgdata;
	char msg[500];

	switch(msg_no) {
	case MSG_NOMAL_CODE:
	case MSG_NOMAL_TIME_CODE:
	case MSG_CANCLE_CODE:
	case MSG_ER_EXC3_CODE:
#if defined(_WIKI) || defined(_HTML)
	case MSG_ER_INIT_CODE:
#endif
		style = MB_OK | MB_ICONINFORMATION;
		break;
	case MSG_ALL_LINE_CODE:
		style = MB_OKCANCEL | MB_ICONQUESTION;
		break;
	default:
		style = MB_OK | MB_ICONSTOP;
		break;
	}

	switch(msg_no) {
	case MSG_NOMAL_CODE:
		msgdata = (char *)MSG_NOMAL;
		break;
	case MSG_NOMAL_TIME_CODE:
#ifdef _UNICODE_TABLE
		sprintf_s(msg, sizeof(msg), MSG_NOMAL_TIME, Tmin, Tsec);
#else  //_UNICODE_TABLE
		SPRINTF(msg, sizeof(msg), MSG_NOMAL_TIME, Tmin, Tsec);
#endif  //_UNICODE_TABLE
		msgdata = msg;
		break;
	case MSG_ALL_LINE_CODE:
		msgdata = (char *)MSG_ALL_LINE;
		break;
	case MSG_CANCLE_CODE:
		msgdata = (char *)MSG_CANCLE;
		break;
	case MSG_ER_CNV_CODE:
		msgdata = (char *)MSG_ER_CNV;
		break;

	case MSG_ER_MEM1_CODE:
		msgdata = (char *)MSG_ER_MEM1;
		break;
	case MSG_ER_MEM2_CODE:
		msgdata = (char *)MSG_ER_MEM2;
		break;
	case MSG_ER_MEM3_CODE:
		msgdata = (char *)MSG_ER_MEM3;
		break;

	case MSG_ER_EXC1_CODE:
		msgdata = (char *)MSG_ER_EXC1;
		break;
	case MSG_ER_EXC2_CODE:
		msgdata = (char *)MSG_ER_EXC2;
		break;
	case MSG_ER_EXC3_CODE:
		msgdata = (char *)MSG_ER_EXC3;
		break;
	case MSG_ER_EXC4_CODE:
		msgdata = (char *)MSG_ER_EXC4;
		break;
	case MSG_ER_EXC5_CODE:
		msgdata = (char *)MSG_ER_EXC5;
		break;

	case MSG_ER_CLP1_CODE:
		msgdata = (char *)MSG_ER_CLP1;
		break;
	case MSG_ER_CLP2_CODE:
		msgdata = (char *)MSG_ER_CLP2;
		break;
	case MSG_ER_CLP3_CODE:
		msgdata = (char *)MSG_ER_CLP3;
		break;
	case MSG_ER_CLP4_CODE:
		msgdata = (char *)MSG_ER_CLP4;
		break;
	case MSG_ER_CLP5_CODE:
		msgdata = (char *)MSG_ER_CLP5;
		break;
	case MSG_ER_CLP6_CODE:
		msgdata = (char *)MSG_ER_CLP6;
		break;
	case MSG_ER_CLP7_CODE:
		msgdata = (char *)MSG_ER_CLP7;
		break;
	case MSG_ER_CLP8_CODE:
		msgdata = (char *)MSG_ER_CLP8;
		break;
	case MSG_ER_CLP9_CODE:
		msgdata = (char *)MSG_ER_CLP9;
		break;

#if defined(_WIKI) || defined(_HTML)
	case MSG_ER_INIT_CODE:
		msgdata = (char *)MSG_ER_INIT;
		break;
#endif

#ifdef _SDK
	case MSG_ER_RDB_CODE:
		msgdata = (char *)MSG_ER_RDB;
		break;
#endif

	case MSG_ER_AREA_CODE:
		msgdata = (char *)MSG_ER_AREA;
		break;
	case MSG_ER_SYSTEM_CODE:
		msgdata = (char *)MSG_ER_SYSTEM;
		break;
	default:
		return 0;
	}

	result = MessageBox( hWnd, msgdata, APP_NAME, style );
	return result;
}
